datablock AudioDescription(AudioMassiveExplosion) {
	volume = "1";
	isLooping = "0";
	is3D = "1";
	minDistance = "500";
	maxDistance = "9999";
	coneInsideAngle = "360";
	coneOutsideAngle = "360";
	coneOutsideVolume = "1";
	coneVector = "0 0 1";
	environmentLevel = "1";
	loopCount = "-1";
	minLoopGap = "0";
	maxLoopGap = "0";
	type = "3";
};

datablock AudioProfile(NuclearDetonationSound) {
	fileName = "fx/weapons/mortar_explode.wav";
	description = "AudioMassiveExplosion";
	Preload = "1";
};

datablock ParticleData(TacNukeTopStreamerFire) {
	dragCoefficient = "1";
	windCoefficient = "0";
	gravityCoefficient = "-0.845";
	inheritedVelFactor = "0";
	constantAcceleration = "0.01";
	lifetimeMS = "8000";
	lifetimeVarianceMS = "700";
	spinSpeed = "0";
	spinRandomMin = "-200";
	spinRandomMax = "200";
	useInvAlpha = "0";
	animateTexture = "0";
	framesPerSec = "1";
	textureName = "special/cloudFlash";
	animTexName[0] = "special/cloudFlash";
	colors[0] = "1.000000 1.000000 0.300000 1.000000";
	colors[1] = "1.000000 0.600000 0.150000 0.300000";
	colors[2] = "1.000000 0.400000 0.000000 0.200000";
	colors[3] = "1.000000 0.200000 0.000000 0.000000";
	sizes[0] = "145";
	sizes[1] = "135";
	sizes[2] = "160";
	sizes[3] = "190";
	times[0] = "0";
	times[1] = "0.333";
	times[2] = "0.666";
	times[3] = "1";
};

datablock ParticleEmitterData(TacNukeTopStreamerFireEmitter) {
	className = "ParticleEmitterData";
	ejectionPeriodMS = "2";
	periodVarianceMS = "0";
	ejectionVelocity = "91";
	velocityVariance = "36";
	ejectionOffset = "18";
	thetaMin = "85";
	thetaMax = "180";
	phiReferenceVel = "0";
	phiVariance = "360";
	overrideAdvance = "0";
	orientParticles = "0";
	orientOnVelocity = "1";
	particles = "TacNukeTopStreamerFire";
	lifetimeMS = "0";
	lifetimeVarianceMS = "0";
	useEmitterSizes = "0";
	useEmitterColors = "0";

	overrideAdvances = "0";
};

datablock ParticleData(TacNukeColumnFire) {
	dragCoefficient = "1";
	windCoefficient = "0";
	gravityCoefficient = "0.5";
	inheritedVelFactor = "0";
	constantAcceleration = "0.01";
	lifetimeMS = "4000";
	lifetimeVarianceMS = "3300";
	spinSpeed = "0";
	spinRandomMin = "-200";
	spinRandomMax = "200";
	useInvAlpha = "0";
	animateTexture = "0";
	framesPerSec = "1";
	textureName = "special/cloudFlash";
	animTexName[0] = "special/cloudFlash";
	colors[0] = "1.000000 1.000000 0.300000 1.000000";
	colors[1] = "1.000000 0.600000 0.100000 0.200000";
	colors[2] = "1.000000 0.400000 0.000000 0.200000";
	colors[3] = "1.000000 0.200000 0.000000 0.000000";
	sizes[0] = "90";
	sizes[1] = "125";
	sizes[2] = "150";
	sizes[3] = "190";
	times[0] = "0";
	times[1] = "0.333";
	times[2] = "0.666";
	times[3] = "1";
};

datablock ParticleEmitterData(TacNukeColumnFireEmitter) {
	className = "ParticleEmitterData";
	ejectionPeriodMS = "10";
	periodVarianceMS = "0";
	ejectionVelocity = "82";
	velocityVariance = "17";
	ejectionOffset = "7";
	thetaMin = "35";
	thetaMax = "55";
	phiReferenceVel = "0";
	phiVariance = "360";
	overrideAdvance = "0";
	orientParticles = "0";
	orientOnVelocity = "1";
	particles = "TacNukeColumnFire";
	lifetimeMS = "0";
	lifetimeVarianceMS = "0";
	useEmitterSizes = "0";
	useEmitterColors = "0";

	overrideAdvances = "0";
};

datablock ParticleData(TacNukeCloudBall) {
	dragCoefficient = "0.6";
	windCoefficient = "0";
	gravityCoefficient = "0";
	inheritedVelFactor = "0";
	constantAcceleration = "0";
	lifetimeMS = "7000";
	lifetimeVarianceMS = "2000";
	spinSpeed = "0";
	spinRandomMin = "-500";
	spinRandomMax = "500";
	useInvAlpha = "0";
	animateTexture = "0";
	framesPerSec = "1";
	textureName = "special/expFlare";
	animTexName[0] = "special/expFlare";
	colors[0] = "1.000000 1.000000 1.000000 0.900000";
	colors[1] = "1.000000 0.400000 0.000000 0.300000";
	colors[2] = "1.000000 0.300000 0.000000 0.000000";
	colors[3] = "1.000000 1.000000 1.000000 1.000000";
	sizes[0] = "75";
	sizes[1] = "250";
	sizes[2] = "400";
	sizes[3] = "1";
	times[0] = "0";
	times[1] = "0.7";
	times[2] = "1";
	times[3] = "2";
};

datablock ParticleEmitterData(TacNukeCloudBallEmitter) {
	className = "ParticleEmitterData";
	ejectionPeriodMS = "3";
	periodVarianceMS = "0";
	ejectionVelocity = "57";
	velocityVariance = "20";
	ejectionOffset = "6";
	thetaMin = "0";
	thetaMax = "110";
	phiReferenceVel = "0";
	phiVariance = "360";
	overrideAdvance = "0";
	orientParticles = "0";
	orientOnVelocity = "1";
	particles = "TacNukeCloudBall";
	lifetimeMS = "3600";
	lifetimeVarianceMS = "0";
	useEmitterSizes = "0";
	useEmitterColors = "0";

	overrideAdvances = "0";
};

datablock ParticleData(TacNukeColumnSmoke) {
	dragCoefficient = "1";
	windCoefficient = "0";
	gravityCoefficient = "0.1";
	inheritedVelFactor = "0";
	constantAcceleration = "0.01";
	lifetimeMS = "26000";
	lifetimeVarianceMS = "5000";
	spinSpeed = "0";
	spinRandomMin = "-160";
	spinRandomMax = "160";
	useInvAlpha = "1";
	animateTexture = "0";
	framesPerSec = "1";
	textureName = "special/Smoke/smoke_001";
	animTexName[0] = "special/Smoke/smoke_001";
	colors[0] = "0.000000 0.000000 0.000000 0.000000";
	colors[1] = "0.200000 0.200000 0.200000 0.200000";
	colors[2] = "0.200000 0.200000 0.200000 0.150000";
	colors[3] = "0.100000 0.100000 0.100000 0.000000";
	sizes[0] = "10";
	sizes[1] = "30";
	sizes[2] = "35";
	sizes[3] = "40";
	times[0] = "0";
	times[1] = "0.15";
	times[2] = "0.85";
	times[3] = "1";
};

datablock ParticleEmitterData(TacNukeColumnEmitter) {
	className = "ParticleEmitterData";
	ejectionPeriodMS = "20";
	periodVarianceMS = "0";
	ejectionVelocity = "19";
	velocityVariance = "18";
	ejectionOffset = "0";
	thetaMin = "85";
	thetaMax = "155";
	phiReferenceVel = "0";
	phiVariance = "360";
	overrideAdvance = "0";
	orientParticles = "0";
	orientOnVelocity = "1";
	particles = "TacNukeColumnSmoke";
	lifetimeMS = "0";
	lifetimeVarianceMS = "0";
	useEmitterSizes = "0";
	useEmitterColors = "0";

	overrideAdvances = "0";
};

datablock ParticleData(TacNukeCloudTopSmoke) {
	dragCoefficient = "1";
	windCoefficient = "0";
	gravityCoefficient = "-0.2";
	inheritedVelFactor = "0";
	constantAcceleration = "0.01";
	lifetimeMS = "29000";
	lifetimeVarianceMS = "14000";
	spinSpeed = "0";
	spinRandomMin = "-110";
	spinRandomMax = "110";
	useInvAlpha = "1";
	animateTexture = "0";
	framesPerSec = "1";
	textureName = "special/Smoke/smoke_001";
	animTexName[0] = "special/Smoke/smoke_001";
	colors[0] = "0.500000 0.300000 0.300000 0.000000";
	colors[1] = "0.200000 0.200000 0.200000 0.250000";
	colors[2] = "0.200000 0.200000 0.200000 0.250000";
	colors[3] = "0.100000 0.100000 0.100000 0.000000";
	sizes[0] = "70";
	sizes[1] = "100";
	sizes[2] = "100";
	sizes[3] = "160";
	times[0] = "0";
	times[1] = "0.1";
	times[2] = "0.8";
	times[3] = "1";
};

datablock ParticleEmitterData(TacNukeCloudTopSmokeEmitter) {
	className = "ParticleEmitterData";
	ejectionPeriodMS = "1";
	periodVarianceMS = "0";
	ejectionVelocity = "89";
	velocityVariance = "78";
	ejectionOffset = "6";
	thetaMin = "100";
	thetaMax = "180";
	phiReferenceVel = "0";
	phiVariance = "360";
	overrideAdvance = "0";
	orientParticles = "0";
	orientOnVelocity = "1";
	particles = "TacNukeCloudTopSmoke";
	lifetimeMS = "4500";
	lifetimeVarianceMS = "0";
	useEmitterSizes = "0";
	useEmitterColors = "0";

	overrideAdvances = "0";
};

datablock ParticleData(TacNukeBaseCenterSmoke) {
	dragCoefficient = "1";
	windCoefficient = "0";
	gravityCoefficient = "-0.01";
	inheritedVelFactor = "0.2";
	constantAcceleration = "0";
	lifetimeMS = "29999";
	lifetimeVarianceMS = "25000";
	spinSpeed = "0";
	spinRandomMin = "-10";
	spinRandomMax = "10";
	useInvAlpha = "1";
	animateTexture = "0";
	framesPerSec = "1";
	textureName = "special/Smoke/bigSmoke";
	animTexName[0] = "special/Smoke/bigSmoke";
	colors[0] = "0.200000 0.200000 0.200000 0.300000";
	colors[1] = "0.200000 0.200000 0.200000 0.600000";
	colors[2] = "0.100000 0.100000 0.100000 0.000000";
	colors[3] = "1.000000 1.000000 1.000000 1.000000";
	sizes[0] = "13";
	sizes[1] = "130";
	sizes[2] = "170";
	sizes[3] = "1";
	times[0] = "0";
	times[1] = "0.4";
	times[2] = "1";
	times[3] = "2";
};

datablock ParticleEmitterData(TacNukeBaseCenterSmokeEmitter) {
	className = "ParticleEmitterData";
	ejectionPeriodMS = "28";
	periodVarianceMS = "0";
	ejectionVelocity = "38";
	velocityVariance = "24";
	ejectionOffset = "18";
	thetaMin = "0";
	thetaMax = "90";
	phiReferenceVel = "0";
	phiVariance = "360";
	overrideAdvance = "0";
	orientParticles = "0";
	orientOnVelocity = "1";
	particles = "TacNukeBaseCenterSmoke";
	lifetimeMS = "4000";
	lifetimeVarianceMS = "0";
	useEmitterSizes = "0";
	useEmitterColors = "0";

	overrideAdvances = "0";
};

datablock ParticleData(TacNukeCloudBaseSmoke) {
	dragCoefficient = "1";
	windCoefficient = "0";
	gravityCoefficient = "-0.01";
	inheritedVelFactor = "0.2";
	constantAcceleration = "0";
	lifetimeMS = "29999";
	lifetimeVarianceMS = "25000";
	spinSpeed = "0";
	spinRandomMin = "-10";
	spinRandomMax = "10";
	useInvAlpha = "1";
	animateTexture = "0";
	framesPerSec = "1";
	textureName = "special/Smoke/bigSmoke";
	animTexName[0] = "special/Smoke/bigSmoke";
	colors[0] = "0.200000 0.200000 0.200000 0.300000";
	colors[1] = "0.200000 0.200000 0.200000 0.600000";
	colors[2] = "0.100000 0.100000 0.100000 0.000000";
	colors[3] = "1.000000 1.000000 1.000000 1.000000";
	sizes[0] = "13";
	sizes[1] = "35";
	sizes[2] = "55";
	sizes[3] = "1";
	times[0] = "0";
	times[1] = "0.6";
	times[2] = "1";
	times[3] = "2";
};

datablock ParticleEmitterData(TacNukeCloudBaseSmokeEmitter) {
	className = "ParticleEmitterData";
	ejectionPeriodMS = "20";
	periodVarianceMS = "0";
	ejectionVelocity = "105";
	velocityVariance = "65";
	ejectionOffset = "18";
	thetaMin = "90";
	thetaMax = "90";
	phiReferenceVel = "0";
	phiVariance = "360";
	overrideAdvance = "0";
	orientParticles = "0";
	orientOnVelocity = "1";
	particles = "TacNukeCloudBaseSmoke";
	lifetimeMS = "4000";
	lifetimeVarianceMS = "0";
	useEmitterSizes = "0";
	useEmitterColors = "0";

	overrideAdvances = "0";
};

datablock ShockwaveData(TacNukeShockwave) {
	className = "ShockwaveData";
	scale = "1 1 1";
	delayMS = "0";
	delayVariance = "0";
	lifetimeMS = "11000";
	lifetimeVariance = "0";
	width = "19";
	numSegments = "240";
	numVertSegments = "12";
	velocity = "150";
	height = "40";
	verticalCurve = "0.95";
	acceleration = "20";
	times[0] = "0";
	times[1] = "0.5";
	times[2] = "1";
	times[3] = "1";
	colors[0] = "1.000000 0.900000 0.600000 1.000000";
	colors[1] = "0.600000 0.600000 0.600000 0.600000";
	colors[2] = "0.600000 0.600000 0.600000 0.000000";
	colors[3] = "1.000000 1.000000 1.000000 1.000000";
	texture[0] = "special/shockwave4";
	texture[1] = "special/gradient";
	texWrap = "7";
	is2D = "0";
	mapToTerrain = "1";
	orientToNormal = "0";
	renderBottom = "1";
	renderSquare = "0";
};

datablock ShockwaveData(TacNukeTidalWave) {
	className = "ShockwaveData";
	scale = "1 1 1";
	delayMS = "0";
	delayVariance = "0";
	lifetimeMS = "11000";
	lifetimeVariance = "0";
	width = "32";
	numSegments = "240";
	numVertSegments = "6";
	velocity = "200";
	height = "7";
	verticalCurve = "0.85";
	acceleration = "20";
	times[0] = "0";
	times[1] = "0.5";
	times[2] = "1";
	times[3] = "1";
	colors[0] = "1.000000 1.000000 1.000000 0.800000";
	colors[1] = "0.700000 0.700000 1.000000 0.600000";
	colors[2] = "0.200000 0.200000 1.000000 0.000000";
	colors[3] = "1.000000 1.000000 1.000000 1.000000";
	texture[0] = "special/watertail1";
	texture[1] = "special/water2";
	texWrap = "9";
	is2D = "0";
	mapToTerrain = "0";
	orientToNormal = "0";
	renderBottom = "0";
	renderSquare = "0";
};

datablock ParticleData(TacNukeCloudChamberVapor) {
	dragCoefficient = "0.6";
	windCoefficient = "0";
	gravityCoefficient = "-0.1";
	inheritedVelFactor = "0";
	constantAcceleration = "0";
	lifetimeMS = "11000";
	lifetimeVarianceMS = "6000";
	spinSpeed = "0";
	spinRandomMin = "-30";
	spinRandomMax = "30";
	useInvAlpha = "0";
	animateTexture = "0";
	framesPerSec = "1";
	textureName = "special/cloudFlash";
	animTexName[0] = "special/cloudFlash";
	colors[0] = "0.950000 0.950000 1.000000 0.000000";
	colors[1] = "0.800000 0.800000 0.950000 0.200000";
	colors[2] = "0.800000 0.800000 0.950000 0.100000";
	colors[3] = "0.550000 0.550000 0.950000 0.000000";
	sizes[0] = "10";
	sizes[1] = "20";
	sizes[2] = "20";
	sizes[3] = "40";
	times[0] = "0";
	times[1] = "0.1";
	times[2] = "0.7";
	times[3] = "1";
};

datablock ParticleData(TacNukeWaterParticles) {
	dragCoefficient = "0.1";
	windCoefficient = "1";
	gravityCoefficient = "1";
	inheritedVelFactor = "0";
	constantAcceleration = "0";
	lifetimeMS = "16000";
	lifetimeVarianceMS = "2000";
	spinSpeed = "0";
	spinRandomMin = "-90";
	spinRandomMax = "90";
	useInvAlpha = "0";
	animateTexture = "0";
	framesPerSec = "1";
	textureName = "special/droplet";
	animTexName[0] = "special/droplet";
	colors[0] = "0.950000 0.950000 1.000000 1.000000";
	colors[1] = "0.800000 0.800000 0.950000 1.000000";
	colors[2] = "0.000000 0.000000 0.400000 0.000000";
	colors[3] = "1.000000 1.000000 1.000000 1.000000";
	sizes[0] = "7";
	sizes[1] = "9";
	sizes[2] = "12";
	sizes[3] = "1";
	times[0] = "0";
	times[1] = "0.5";
	times[2] = "1";
	times[3] = "2";
};

datablock ParticleEmitterData(TacNukeCloudChamberVaporEmitter1) {
	className = "ParticleEmitterData";
	ejectionPeriodMS = "1";
	periodVarianceMS = "0";
	ejectionVelocity = "30";
	velocityVariance = "0";
	ejectionOffset = "240";
	thetaMin = "69";
	thetaMax = "81";
	phiReferenceVel = "0";
	phiVariance = "360";
	overrideAdvance = "0";
	orientParticles = "0";
	orientOnVelocity = "1";
	particles = "TacNukeCloudChamberVapor";
	lifetimeMS = "5000";
	lifetimeVarianceMS = "0";
	useEmitterSizes = "0";
	useEmitterColors = "0";

	overrideAdvances = "0";
};

datablock ParticleEmitterData(TacNukeCloudChamberVaporEmitter2) {
	className = "ParticleEmitterData";
	ejectionPeriodMS = "1";
	periodVarianceMS = "0";
	ejectionVelocity = "30";
	velocityVariance = "0";
	ejectionOffset = "190";
	thetaMin = "38";
	thetaMax = "49";
	phiReferenceVel = "0";
	phiVariance = "360";
	overrideAdvance = "0";
	orientParticles = "0";
	orientOnVelocity = "1";
	particles = "TacNukeCloudChamberVapor";
	lifetimeMS = "3000";
	lifetimeVarianceMS = "0";
	useEmitterSizes = "0";
	useEmitterColors = "0";

	overrideAdvances = "0";
};

datablock ParticleEmitterData(TacNukeWaterSplashEmitter) {
	className = "ParticleEmitterData";
	ejectionPeriodMS = "1";
	periodVarianceMS = "0";
	ejectionVelocity = "100";
	velocityVariance = "70";
	ejectionOffset = "10";
	thetaMin = "20";
	thetaMax = "24";
	phiReferenceVel = "0";
	phiVariance = "360";
	overrideAdvance = "0";
	orientParticles = "0";
	orientOnVelocity = "1";
	particles = "TacNukeWaterParticles";
	lifetimeMS = "3000";
	lifetimeVarianceMS = "0";
	useEmitterSizes = "0";
	useEmitterColors = "0";

	overrideAdvances = "0";
};

datablock ExplosionData(TacNukeWaterExplosion) {
	className = "ExplosionData";
	faceViewer = "0";
	particleDensity = "10";
	particleRadius = "1";
	explosionScale = "1 1 1";
	playSpeed = "1";
	emitter[0] = "TacNukeWaterSplashEmitter";
	emitter[1] = "TacNukeWaterSplashEmitter";
	Shockwave = "TacNukeTidalWave";
	shockwaveOnTerrain = "0";
	debrisThetaMin = "0";
	debrisThetaMax = "90";
	debrisPhiMin = "0";
	debrisPhiMax = "360";
	debrisNum = "1";
	debrisNumVariance = "0";
	debrisVelocity = "2";
	debrisVelocityVariance = "0";
	delayMS = "0";
	delayVariance = "0";
	lifetimeMS = "1000";
	lifetimeVariance = "0";
	offset = "0";
	times[0] = "0";
	times[1] = "1";
	times[2] = "1";
	times[3] = "1";
	sizes[0] = "1 1 1";
	sizes[1] = "1 1 1";
	sizes[2] = "1 1 1";
	sizes[3] = "1 1 1";
	shakeCamera = "0";
	camShakeFreq = "10 10 10";
	camShakeAmp = "1 1 1";
	camShakeDuration = "1.5";
	camShakeRadius = "10";
	camShakeFalloff = "10";
};

datablock ExplosionData(TacNukeCloudExplosion) {
	className = "ExplosionData";
	faceViewer = "0";
	particleDensity = "10";
	particleRadius = "1";
	explosionScale = "1 1 1";
	playSpeed = "1";
	emitter[0] = "TacNukeCloudChamberVaporEmitter1";
	emitter[1] = "TacNukeCloudChamberVaporEmitter2";
	shockwaveOnTerrain = "0";
	debrisThetaMin = "0";
	debrisThetaMax = "90";
	debrisPhiMin = "0";
	debrisPhiMax = "360";
	debrisNum = "1";
	debrisNumVariance = "0";
	debrisVelocity = "2";
	debrisVelocityVariance = "0";
	delayMS = "0";
	delayVariance = "0";
	lifetimeMS = "1000";
	lifetimeVariance = "0";
	offset = "0";
	times[0] = "0";
	times[1] = "1";
	times[2] = "1";
	times[3] = "1";
	sizes[0] = "1 1 1";
	sizes[1] = "1 1 1";
	sizes[2] = "1 1 1";
	sizes[3] = "1 1 1";
	shakeCamera = "0";
	camShakeFreq = "10 10 10";
	camShakeAmp = "1 1 1";
	camShakeDuration = "1.5";
	camShakeRadius = "10";
	camShakeFalloff = "10";
};

datablock ExplosionData(TacNukeShakeExplosion) {
	className = "ExplosionData";
	faceViewer = "0";
	particleDensity = "10";
	particleRadius = "1";
	explosionScale = "1 1 1";
	playSpeed = "1";
	Shockwave = "TacNukeShockwave";
	shockwaveOnTerrain = "0";
    soundProfile = "NuclearDetonationSound";
    debrisThetaMin = "0";
	debrisThetaMax = "90";
	debrisPhiMin = "0";
	debrisPhiMax = "360";
	debrisNum = "1";
	debrisNumVariance = "0";
	debrisVelocity = "2";
	debrisVelocityVariance = "0";
	delayMS = "0";
	delayVariance = "0";
	lifetimeMS = "1000";
	lifetimeVariance = "0";
	offset = "0";
	times[0] = "0";
	times[1] = "1";
	times[2] = "1";
	times[3] = "1";
	sizes[0] = "1 1 1";
	sizes[1] = "1 1 1";
	sizes[2] = "1 1 1";
	sizes[3] = "1 1 1";
	shakeCamera = "1";
	camShakeFreq = "2 2 14";
	camShakeAmp = "5 5 50";
	camShakeDuration = "8";
	camShakeRadius = "1500";
	camShakeFalloff = "10";
};

datablock ExplosionData(TacNukeFireballSmokeExp) {
	className = "ExplosionData";
	faceViewer = "0";
	particleDensity = "10";
	particleRadius = "1";
	explosionScale = "1 1 1";
	playSpeed = "1";
	emitter[0] = "TacNukeCloudBaseSmokeEmitter";
	emitter[1] = "TacNukeBaseCenterSmokeEmitter";
	shockwaveOnTerrain = "0";
	debrisThetaMin = "0";
	debrisThetaMax = "90";
	debrisPhiMin = "0";
	debrisPhiMax = "360";
	debrisNum = "1";
	debrisNumVariance = "0";
	debrisVelocity = "2";
	debrisVelocityVariance = "0";
	delayMS = "0";
	delayVariance = "0";
	lifetimeMS = "1000";
	lifetimeVariance = "0";
	offset = "0";
	times[0] = "0";
	times[1] = "1";
	times[2] = "1";
	times[3] = "1";
	sizes[0] = "1 1 1";
	sizes[1] = "1 1 1";
	sizes[2] = "1 1 1";
	sizes[3] = "1 1 1";
	shakeCamera = "0";
	camShakeFreq = "10 10 10";
	camShakeAmp = "1 1 1";
	camShakeDuration = "1.5";
	camShakeRadius = "10";
	camShakeFalloff = "10";
};

datablock ExplosionData(TacNukeSmokeCapExp) {
	className = "ExplosionData";
	faceViewer = "0";
	particleDensity = "10";
	particleRadius = "1";
	explosionScale = "1 1 1";
	playSpeed = "1";
	emitter[0] = "TacNukeCloudTopSmokeEmitter";
	shockwaveOnTerrain = "0";
	debrisThetaMin = "0";
	debrisThetaMax = "90";
	debrisPhiMin = "0";
	debrisPhiMax = "360";
	debrisNum = "1";
	debrisNumVariance = "0";
	debrisVelocity = "2";
	debrisVelocityVariance = "0";
	delayMS = "0";
	delayVariance = "0";
	lifetimeMS = "1000";
	lifetimeVariance = "0";
	offset = "0";
	times[0] = "0";
	times[1] = "1";
	times[2] = "1";
	times[3] = "1";
	sizes[0] = "1 1 1";
	sizes[1] = "1 1 1";
	sizes[2] = "1 1 1";
	sizes[3] = "1 1 1";
	shakeCamera = "0";
	camShakeFreq = "10 10 10";
	camShakeAmp = "1 1 1";
	camShakeDuration = "1.5";
	camShakeRadius = "10";
	camShakeFalloff = "10";
};

datablock ExplosionData(TacNukeFireballFireExp) {
	className = "ExplosionData";
	soundProfile = "NuclearDetonationSound";
	faceViewer = "0";
	particleDensity = "10";
	particleRadius = "1";
	explosionScale = "1 1 1";
	playSpeed = "1";
	emitter[0] = "TacNukeCloudBallEmitter";
	shockwaveOnTerrain = "0";
	debrisThetaMin = "0";
	debrisThetaMax = "90";
	debrisPhiMin = "0";
	debrisPhiMax = "360";
	debrisNum = "1";
	debrisNumVariance = "0";
	debrisVelocity = "2";
	debrisVelocityVariance = "0";
	delayMS = "0";
	delayVariance = "0";
	lifetimeMS = "1000";
	lifetimeVariance = "0";
	offset = "0";
	times[0] = "0";
	times[1] = "1";
	times[2] = "1";
	times[3] = "1";
	sizes[0] = "1 1 1";
	sizes[1] = "1 1 1";
	sizes[2] = "1 1 1";
	sizes[3] = "1 1 1";
	shakeCamera = "0";
	camShakeFreq = "10 10 10";
	camShakeAmp = "1 1 1";
	camShakeDuration = "1.5";
	camShakeRadius = "10";
	camShakeFalloff = "10";
};

datablock TracerProjectileData(TacNukeWater) {
	className = "TracerProjectileData";
	emitterDelay = "-1";
	velInheritFactor = "0";
	directDamage = "0";
	hasDamageRadius = "0";
	indirectDamage = "0";
	damageRadius = "0";
	radiusDamageType = "0";
	kickBackStrength = "0";
	Explosion = "TacNukeWaterExplosion";
	hasLight = "0";
	lightRadius = "1";
	lightColor = "1.000000 1.000000 1.000000 1.000000";
	hasLightUnderwaterColor = "0";
	underWaterLightColor = "1.000000 1.000000 1.000000 1.000000";
	explodeOnWaterImpact = "0";
	depthTolerance = "5";
	bubbleEmitTime = "0.5";
	faceViewer = "0";
	scale = "1 1 1";
	dryVelocity = "0.1";
	wetVelocity = "0.1";
	fizzleTimeMS = "32";
	lifetimeMS = "32";
	explodeOnDeath = "1";
	reflectOnWaterImpactAngle = "0";
	deflectionOnWaterImpact = "0";
	fizzleUnderwaterMS = "-1";
	activateDelayMS = "-1";
	doDynamicClientHits = "0";
	tracerLength = "1";
	tracerMinPixels = "1";
	tracerAlpha = "0";
	tracerColor = "0.000000 0.000000 0.000000 0.000000";
	tracerTex[0] = "special/tracer00";
	tracerTex[1] = "special/tracercross";
	tracerWidth = "0.1";
	crossViewAng = "0.99";
	crossSize = "0.1";
	renderCross = "0";

	isFXUnit = "1";
};

datablock TracerProjectileData(TacNukeCloud) {
	className = "TracerProjectileData";
	emitterDelay = "-1";
	velInheritFactor = "0";
	directDamage = "0";
	hasDamageRadius = "0";
	indirectDamage = "0";
	damageRadius = "0";
	radiusDamageType = "0";
	kickBackStrength = "0";
	Explosion = "TacNukeCloudExplosion";
	hasLight = "0";
	lightRadius = "1";
	lightColor = "1.000000 1.000000 1.000000 1.000000";
	hasLightUnderwaterColor = "0";
	underWaterLightColor = "1.000000 1.000000 1.000000 1.000000";
	explodeOnWaterImpact = "0";
	depthTolerance = "5";
	bubbleEmitTime = "0.5";
	faceViewer = "0";
	scale = "1 1 1";
	dryVelocity = "0.1";
	wetVelocity = "0.1";
	fizzleTimeMS = "32";
	lifetimeMS = "32";
	explodeOnDeath = "1";
	reflectOnWaterImpactAngle = "0";
	deflectionOnWaterImpact = "0";
	fizzleUnderwaterMS = "-1";
	activateDelayMS = "-1";
	doDynamicClientHits = "0";
	tracerLength = "1";
	tracerMinPixels = "1";
	tracerAlpha = "0";
	tracerColor = "0.000000 0.000000 0.000000 0.000000";
	tracerTex[0] = "special/tracer00";
	tracerTex[1] = "special/tracercross";
	tracerWidth = "0.1";
	crossViewAng = "0.99";
	crossSize = "0.1";
	renderCross = "0";

	isFXUnit = "1";
};

datablock TracerProjectileData(TacNukeShake) {
	className = "TracerProjectileData";
	emitterDelay = "-1";
	velInheritFactor = "0";
	directDamage = "0";
	hasDamageRadius = "0";//"1";//"0";
	indirectDamage = "0";//"10";//"0";
	damageRadius = "0";//"1500";//"0";
	radiusDamageType = "0";
	kickBackStrength = "0";
	Explosion = "TacNukeShakeExplosion";
	hasLight = "0";
	lightRadius = "1";
	lightColor = "1.000000 1.000000 1.000000 1.000000";
	hasLightUnderwaterColor = "0";
	underWaterLightColor = "1.000000 1.000000 1.000000 1.000000";
	explodeOnWaterImpact = "0";
	depthTolerance = "5";
	bubbleEmitTime = "0.5";
	faceViewer = "0";
	scale = "1 1 1";
	dryVelocity = "0.1";
	wetVelocity = "0.1";
	fizzleTimeMS = "32";
	lifetimeMS = "32";
	explodeOnDeath = "1";
	reflectOnWaterImpactAngle = "0";
	deflectionOnWaterImpact = "0";
	fizzleUnderwaterMS = "-1";
	activateDelayMS = "-1";
	doDynamicClientHits = "0";
	tracerLength = "1";
	tracerMinPixels = "1";
	tracerAlpha = "0";
	tracerColor = "0.000000 0.000000 0.000000 0.000000";
	tracerTex[0] = "special/tracer00";
	tracerTex[1] = "special/tracercross";
	tracerWidth = "0.1";
	crossViewAng = "0.99";
	crossSize = "0.1";
	renderCross = "0";

	isFXUnit = "1";
};

datablock TracerProjectileData(TacNukeFireball) {
	className = "TracerProjectileData";
	emitterDelay = "-1";
	velInheritFactor = "0";
	directDamage = "0";
	hasDamageRadius = "0";
	indirectDamage = "0";
	damageRadius = "0";
	radiusDamageType = "0";
	kickBackStrength = "0";
	Explosion = "TacNukeFireballFireExp";
	hasLight = "0";
	lightRadius = "1";
	lightColor = "1.000000 1.000000 1.000000 1.000000";
	hasLightUnderwaterColor = "0";
	underWaterLightColor = "1.000000 1.000000 1.000000 1.000000";
	explodeOnWaterImpact = "0";
	depthTolerance = "5";
	bubbleEmitTime = "0.5";
	faceViewer = "0";
	scale = "1 1 1";
	dryVelocity = "0.1";
	wetVelocity = "0.1";
	fizzleTimeMS = "32";
	lifetimeMS = "32";
	explodeOnDeath = "1";
	reflectOnWaterImpactAngle = "0";
	deflectionOnWaterImpact = "0";
	fizzleUnderwaterMS = "-1";
	activateDelayMS = "-1";
	doDynamicClientHits = "0";
	tracerLength = "1";
	tracerMinPixels = "1";
	tracerAlpha = "0";
	tracerColor = "0.000000 0.000000 0.000000 0.000000";
	tracerTex[0] = "special/tracer00";
	tracerTex[1] = "special/tracercross";
	tracerWidth = "0.1";
	crossViewAng = "0.99";
	crossSize = "0.1";
	renderCross = "0";

	isFXUnit = "1";
};

datablock TracerProjectileData(TacNukeShroomCloud) {
	className = "TracerProjectileData";
	emitterDelay = "-1";
	velInheritFactor = "0";
	directDamage = "0";
	hasDamageRadius = "0";
	indirectDamage = "0";
	damageRadius = "0";
	radiusDamageType = "0";
	kickBackStrength = "0";
	Explosion = "TacNukeFireballFireExp";
	hasLight = "0";
	lightRadius = "1";
	lightColor = "1.000000 1.000000 1.000000 1.000000";
	hasLightUnderwaterColor = "0";
	underWaterLightColor = "1.000000 1.000000 1.000000 1.000000";
	explodeOnWaterImpact = "0";
	depthTolerance = "5";
	bubbleEmitTime = "0.5";
	faceViewer = "0";
	scale = "1 1 1";
	dryVelocity = "0.1";
	wetVelocity = "0.1";
	fizzleTimeMS = "32";
	lifetimeMS = "32";
	explodeOnDeath = "1";
	reflectOnWaterImpactAngle = "0";
	deflectionOnWaterImpact = "0";
	fizzleUnderwaterMS = "-1";
	activateDelayMS = "-1";
	doDynamicClientHits = "0";
	tracerLength = "1";
	tracerMinPixels = "1";
	tracerAlpha = "0";
	tracerColor = "0.000000 0.000000 0.000000 0.000000";
	tracerTex[0] = "special/tracer00";
	tracerTex[1] = "special/tracercross";
	tracerWidth = "0.1";
	crossViewAng = "0.99";
	crossSize = "0.1";
	renderCross = "0";

	isFXUnit = "1";
};

datablock TracerProjectileData(TacNukeSmokeFX) {
	className = "TracerProjectileData";
	emitterDelay = "-1";
	velInheritFactor = "0";
	directDamage = "0";
	hasDamageRadius = "0";
	indirectDamage = "0";
	damageRadius = "0";
	radiusDamageType = "0";
	kickBackStrength = "0";
	Explosion = "TacNukeFireballSmokeExp";
	hasLight = "0";
	lightRadius = "1";
	lightColor = "1.000000 1.000000 1.000000 1.000000";
	hasLightUnderwaterColor = "0";
	underWaterLightColor = "1.000000 1.000000 1.000000 1.000000";
	explodeOnWaterImpact = "0";
	depthTolerance = "5";
	bubbleEmitTime = "0.5";
	faceViewer = "0";
	scale = "1 1 1";
	dryVelocity = "0.1";
	wetVelocity = "0.1";
	fizzleTimeMS = "32";
	lifetimeMS = "32";
	explodeOnDeath = "1";
	reflectOnWaterImpactAngle = "0";
	deflectionOnWaterImpact = "0";
	fizzleUnderwaterMS = "-1";
	activateDelayMS = "-1";
	doDynamicClientHits = "0";
	tracerLength = "1";
	tracerMinPixels = "1";
	tracerAlpha = "0";
	tracerColor = "0.000000 0.000000 0.000000 0.000000";
	tracerTex[0] = "special/tracer00";
	tracerTex[1] = "special/tracercross";
	tracerWidth = "0.1";
	crossViewAng = "0.99";
	crossSize = "0.1";
	renderCross = "0";

	isFXUnit = "1";
};

datablock LinearProjectileData(TacNukeColumnStream1) {
	className = "LinearProjectileData";
	projectileShapeName = "turret_muzzlepoint.dts";
	emitterDelay = "-1";
	velInheritFactor = "0";
	directDamage = "0";
	hasDamageRadius = "0";
	indirectDamage = "0";
	damageRadius = "0";
	radiusDamageType = "0";
	kickBackStrength = "0";
	baseEmitter = "TacNukeColumnEmitter";
	hasLight = "0";
	lightRadius = "20";
	lightColor = "1.000000 1.000000 1.000000 1.000000";
	hasLightUnderwaterColor = "0";
	underWaterLightColor = "1.000000 1.000000 1.000000 1.000000";
	explodeOnWaterImpact = "0";
	depthTolerance = "5";
	bubbleEmitTime = "0.5";
	faceViewer = "0";
	scale = "1 1 1";
	dryVelocity = "8.6";
	wetVelocity = "8.6";
	fizzleTimeMS = "32999";
	lifetimeMS = "33000";
	explodeOnDeath = "1";
	reflectOnWaterImpactAngle = "0";
	deflectionOnWaterImpact = "0";
	fizzleUnderwaterMS = "-1";
	activateDelayMS = "-1";
	doDynamicClientHits = "0";
};

datablock LinearProjectileData(TacNukeColumnStream2) {
	className = "LinearProjectileData";
	projectileShapeName = "turret_muzzlepoint.dts";
	emitterDelay = "-1";
	velInheritFactor = "0";
	directDamage = "0";
	hasDamageRadius = "0";
	indirectDamage = "0";
	damageRadius = "0";
	radiusDamageType = "0";
	kickBackStrength = "0";
	baseEmitter = "TacNukeTopStreamerFireEmitter";
	delayEmitter = "TacNukeColumnFireEmitter";
	Explosion = "TacNukeSmokeCapExp";
	hasLight = "1";
	lightRadius = "20";
	lightColor = "1.000000 1.000000 1.000000 1.000000";
	hasLightUnderwaterColor = "0";
	underWaterLightColor = "1.000000 1.000000 1.000000 1.000000";
	explodeOnWaterImpact = "0";
	depthTolerance = "5";
	bubbleEmitTime = "0.5";
	faceViewer = "0";
	scale = "1 1 1";
	dryVelocity = "8.6";
	wetVelocity = "8.6";
	fizzleTimeMS = "26999";
	lifetimeMS = "27000";
	explodeOnDeath = "1";
	reflectOnWaterImpactAngle = "0";
	deflectionOnWaterImpact = "0";
	fizzleUnderwaterMS = "-1";
	activateDelayMS = "-1";
	doDynamicClientHits = "0";
};

datablock ItemData(NukeLauncherAmmo)
{
   className = Ammo;
   catagory = "Ammo";
   shapeFile = "ammo_mortar.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
   pickUpName = "some nuke ammo";

   computeCRC = true;
};

datablock ItemData(NukeLauncher)
{
   className = Weapon;
   catagory = "Spawn Items";
   shapeFile = "weapon_mortar.dts";
   image = TacNukeImage;
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
   pickUpName = "a nuke";

   computeCRC = true;
   emap = true;
};

datablock ShapeBaseImageData(TacNukeImage)
{
   className = WeaponImage;
   shapeFile = "weapon_mortar.dts";
   item = NukeLauncher;
   ammo = NukeLauncherAmmo;
   offset = "0 0 0";
   emap = true;

   //projectile = TacNukeColumnStream2;
   //projectileType = LinearProjectile;

   stateName[0] = "Activate";
   stateTransitionOnTimeout[0] = "ActivateReady";
   stateTimeoutValue[0] = 0.5;
   stateSequence[0] = "Activate";
   stateSound[0] = MortarSwitchSound;

   stateName[1] = "ActivateReady";
   stateTransitionOnLoaded[1] = "Ready";
   stateTransitionOnNoAmmo[1] = "NoAmmo";

   stateName[2] = "Ready";
   stateTransitionOnNoAmmo[2] = "NoAmmo";
   stateTransitionOnTriggerDown[2] = "Fire";
   //stateSound[2] = MortarIdleSound;

   stateName[3] = "Fire";
   stateSequence[3] = "Recoil";
   stateTransitionOnTimeout[3] = "Reload";
   stateTimeoutValue[3] = 0.8;
   stateFire[3] = true;
   stateRecoil[3] = LightRecoil;
   stateAllowImageChange[3] = false;
   stateScript[3] = "onFire";
   stateSound[3] = MortarFireSound;

   stateName[4] = "Reload";
   stateTransitionOnNoAmmo[4] = "NoAmmo";
   stateTransitionOnTimeout[4] = "Ready";
   stateTimeoutValue[4] = 2.0;
   stateAllowImageChange[4] = false;
   stateSequence[4] = "Reload";
   stateSound[4] = MortarReloadSound;

   stateName[5] = "NoAmmo";
   stateTransitionOnAmmo[5] = "Reload";
   stateSequence[5] = "NoAmmo";
   stateTransitionOnTriggerDown[5] = "DryFire";

   stateName[6]       = "DryFire";
   stateSound[6]      = MortarDryFireSound;
   stateTimeoutValue[6]        = 1.5;
   stateTransitionOnTimeout[6] = "NoAmmo";
};

function TacNukeImage::onFire(%data,%obj,%slot)
{
   %p = new TracerProjectile(){
      datablock = TacNukeSmokeFX;
      initialDirection = %obj.getMuzzleVector(%slot);
      initialPosition  = %obj.getMuzzlePoint(%slot);
      sourceObject     = %obj;
      sourceSlot       = %slot;
      vehicleObject    = %vehicle;
   };

   %p = new LinearProjectile(){
      datablock = TacNukeColumnStream1;
      initialDirection = %obj.getMuzzleVector(%slot);
      initialPosition  = %obj.getMuzzlePoint(%slot);
      sourceObject     = %obj;
      sourceSlot       = %slot;
      vehicleObject    = %vehicle;
   };

   %p = new LinearProjectile(){
      datablock = TacNukeColumnStream2;
      initialDirection = %obj.getMuzzleVector(%slot);
      initialPosition  = %obj.getMuzzlePoint(%slot);
      sourceObject     = %obj;
      sourceSlot       = %slot;
      vehicleObject    = %vehicle;
   };
}

function TacNukeColumnStream2::onExplode(%data, %proj, %pos, %mod)
{
   if (%data.hasDamageRadius)
      RadiusExplosion(%proj, %pos, %data.damageRadius, %data.indirectDamage, %data.kickBackStrength, %proj.sourceObject, %data.radiusDamageType);

   %p = new TracerProjectile(){
      datablock = TacNukeWater;
      initialDirection = "0 0 0";
      initialPosition  = vectorAdd(%pos,"0 0 10");
   };

   //%p = new TracerProjectile(){
   //   datablock = TacNukeCloud;
   //   initialDirection = "0 0 0";
   //   initialPosition  = vectorAdd(%pos,"0 0 10");
   //};

   %p = new TracerProjectile(){
      datablock = TacNukeShake;
      initialDirection = "0 0 0";
      initialPosition  = vectorAdd(%pos,"0 0 10");
   };

   //%p = new TracerProjectile(){
   //   datablock = TacNukeFireball;
   //   initialDirection = "0 0 0";
   //   initialPosition  = %pos;
   //};

   //%p = new TracerProjectile(){
   //   datablock = TacNukeShroomCloud;
   //   initialDirection = "0 0 0";
   //   initialPosition  = %pos;
   //};

   //The Missiles
   for(%i=0;%i<90;%i++)
   {
      %x = getRandomN(22.5,1);
      %y = getRandomN(22.5,1);
      %z = getRandomN(22.5,1);
      %p = new SeekerProjectile()
      {
         datablock = ShoulderMissile;
         initialPosition = %pos;
         initialDirection = %x SPC %y SPC %z;
      };
   }
   for(%i=0;%i<90;%i++)
   {
      %x = getRandom(22.5,1);
      %y = getRandom(22.5,1);
      %z = getRandomN(22.5,1);
      %p = new SeekerProjectile()
      {
         datablock = ShoulderMissile;
         initialPosition = %pos;
         initialDirection = %x SPC %y SPC %z;
      };
   }
}
