//umm grenade launching thing
//"rapid launcher"


//particles
//////////
////////
//////
datablock ParticleData(rapidbubbleParticle)
{
    dragCoefficient = 0;
    gravityCoefficient = -0.01;
    windCoefficient = 0;
    inheritedVelFactor = 0;
    constantAcceleration = 0;
    lifetimeMS = 0;
    lifetimeVarianceMS = 225;
    useInvAlpha = 0;
    spinRandomMin = -200;
    spinRandomMax = 750;
    textureName = "special/cloudflash8.png";
    times[0] = 0;
    times[1] = 0.467742;
    times[2] = 1;
    colors[0] = "0.165354 0.176000 1.000000 1.000000";
    colors[1] = "0.212598 0.240000 1.000000 0.500000";
    colors[2] = "0.433071 0.440000 1.000000 0.129032";
    sizes[0] = 4.85484;
    sizes[1] = 1.97581;
    sizes[2] = 0.33871;
};

datablock ParticleEmitterData(rapidbubbleEmitter)
{
    ejectionPeriodMS = 6;
    periodVarianceMS = 3;
    ejectionVelocity = 6.80645;
    velocityVariance = 6.80645;
    ejectionOffset =   0;
    thetaMin = 34.8387;
    thetaMax = 0;
    phiReferenceVel = 0;
    phiVariance = 360;
    overrideAdvances = 0;
    orientParticles= 0;
    orientOnVelocity = 1;
    particles = "rapidbubbleParticle";
};
datablock ParticleData(rapidexplosionParticle)
{
    dragCoefficient = 0;
    gravityCoefficient = 0.2;
    windCoefficient = 0;
    inheritedVelFactor = 0.2;
    constantAcceleration = 0;
    lifetimeMS = 0;
    lifetimeVarianceMS = 983;
    useInvAlpha = 0;
    spinRandomMin = 0;
    spinRandomMax = 0;
    textureName = "particleTest";
    times[0] = 0;
    times[1] = 1;
    colors[0] = "0.000000 1.000000 1.000000 1.000000";
    colors[1] = "0.560000 0.360000 0.260000 0.000000";
    sizes[0] = 7;
    sizes[1] = 2;
};

datablock ParticleEmitterData(rapidexplosionEmitter)
{
    ejectionPeriodMS = 1;
    periodVarianceMS = 0;
    ejectionVelocity = 5;
    velocityVariance = 1;
    ejectionOffset =   4.51613;
    thetaMin = 0;
    thetaMax = 90;
    phiReferenceVel = 0;
    phiVariance = 360;
    overrideAdvances = 0;
    orientParticles= 0;
    orientOnVelocity = 1;
    particles = "rapidexplosionParticle";
};
datablock ParticleData(rapidexplosionsparksParticle)
{
    dragCoefficient = 0;
    gravityCoefficient = 0;
    windCoefficient = 0;
    inheritedVelFactor = 0.2;
    constantAcceleration = -0;
    lifetimeMS = 7661;
    lifetimeVarianceMS = 0;
    useInvAlpha = 0;
    spinRandomMin = 0;
    spinRandomMax = 0;
    textureName = "special/crescent3";
    times[0] = 0;
    times[1] = 0.5;
    times[2] = 0.666;
    times[3] = 1;
    colors[0] = "0.000000 0.448000 1.000000 1.000000";
    colors[1] = "0.000000 0.000000 1.000000 1.000000";
    colors[2] = "0.000000 0.400000 1.000000 1.000000";
    colors[3] = "0.000000 1.000000 1.000000 1.000000";
    sizes[0] = 4;
    sizes[1] = 8;
    sizes[2] = 9;
    sizes[3] = 0;
};

datablock ParticleEmitterData(rapidexplosionsparksEmitter)
{
    ejectionPeriodMS = 1;
    periodVarianceMS = 0;
    ejectionVelocity = 40;
    velocityVariance = 5;
    ejectionOffset =   0;
    thetaMin = 0;
    thetaMax = 90;
    phiReferenceVel = 0;
    phiVariance = 360;
    overrideAdvances = 0;
    orientParticles= 1;
    orientOnVelocity = 1;
    particles = "rapidexplosionsparksParticle";
};
datablock ParticleData(rapidtrailParticle)
{
    dragCoefficient = 0;
    gravityCoefficient = -0.01;
    windCoefficient = 0;
    inheritedVelFactor = 0;
    constantAcceleration = 0;
    lifetimeMS = 4193;
    lifetimeVarianceMS = 491;
    useInvAlpha = 0;
    spinRandomMin = -200;
    spinRandomMax = 750;
    textureName = "special/underwaterSpark.PNG";
    times[0] = 0;
    times[1] = 0.467742;
    times[2] = 1;
    colors[0] = "0.000000 0.000000 1.000000 1.000000";
    colors[1] = "0.000000 0.240000 1.000000 0.500000";
    colors[2] = "0.433071 0.440000 1.000000 0.129032";
    sizes[0] = 4.85484;
    sizes[1] = 1.97581;
    sizes[2] = 0.33871;
};

datablock ParticleEmitterData(rapidtrailEmitter)
{
    ejectionPeriodMS = 6;
    periodVarianceMS = 0;
    ejectionVelocity = 6.80645;
    velocityVariance = 6.80645;
    ejectionOffset =   0;
    thetaMin = 0;
    thetaMax = 0;
    phiReferenceVel = 360;
    phiVariance = 11.6129;
    overrideAdvances = 0;
    orientParticles= 0;
    orientOnVelocity = 1;
    particles = "rapidtrailParticle";
};
//end particles///////////////////////
/////////////////////////////////////
//shockwave
///////////////////////////////////
datablock ShockwaveData(rapidShockwave)
{
   width = 6.0;
   numSegments = 35;
   numVertSegments = 10;
   velocity = 10;
   acceleration = 40.0;
   lifetimeMS = 1900;
   height = 8.0;
   verticalCurve = 9;
   is2D = false;

   texture[0] = "special/shockwave5";
   texture[1] = "special/gradient";
   texWrap = 6.0;

   times[0] = 0.0;
   times[1] = 0.5;
   times[2] = 1.0;

   colors[0] = "0 0 1 1";
   colors[1] = "0 .5 1 .8";
   colors[2] = "0 1 1 .3";

   mapToTerrain = false;
   orientToNormal = false;
   renderBottom = true;
};
//explosions
///////////////
/////////////
datablock ExplosionData(rapidSubExplosion)
{
   explosionShape = "disc_explosion.dts";
   faceViewer           = true;

   delayMS = 0;

   offset = 5.0;

   playSpeed = 0.8;

   sizes[0] = "1.0 1.0 1.0";
   sizes[1] = "1.0 1.0 1.0";
   times[0] = 0.0;
   times[1] = 1.0;
};


datablock ExplosionData(rapidExplosion)
{
   soundProfile   = MortarExplosionSound;

   shockwave = rapidShockwave;
   shockwaveOnTerrain = false;

   subExplosion[0] = rapidSubExplosion;

   emitter[0] = rapidexplosionsparksEmitter;
   emitter[1] = rapidexplosionemitter;

   shakeCamera = true;
   camShakeFreq = "8.0 9.0 7.0";
   camShakeAmp = "100.0 100.0 100.0";
   camShakeDuration = 1.3;
   camShakeRadius = 45.0;
};





/////////////////////////////////////////
//projectile////////////////////////////
///////////////////////////////////////
datablock GrenadeProjectileData(rapidShot)
{
   projectileShapeName = "mortar_projectile.dts";
   emitterDelay        = -1;
   directDamage        = 0.0;
   hasDamageRadius     = true;
   indirectDamage      = 1.0;
   damageRadius        = 40.0;
   radiusDamageType    = $DamageType::Mortar;
   kickBackStrength    = 7500;

   explosion           = "rapidExplosion";
   underwaterExplosion = "rapidExplosion";
   velInheritFactor    = 1;
   splash              = MortarSplash;
   depthTolerance      = 10.0; // depth at which it uses underwater explosion

   baseEmitter         = rapidtrailemitter;
   bubbleEmitter       = rapidbubbleemitter;

   grenadeElasticity = 0.45;
   grenadeFriction   = 0.4;
   armingDelayMS     = 1000;
   muzzleVelocity    = 80.7;
   drag              = 0.1;

   sound			 = MortarProjectileSound;

   hasLight    = true;
   lightRadius = 4;
   lightColor  = "0 1 0";

   hasLightUnderwaterColor = true;
   underWaterLightColor = "0 1 0";

};
////////////////////////////////////////
//////////////////////////////////////
////////////////////////////////////
//////////////////////////////////
//image related stuff////////////
////////////////////////////////
datablock ItemData(rapidlauncher)
{
   className = Weapon;
   catagory = "Spawn Items";
   shapeFile = "weapon_mortar.dts";
   image = MortarImage;
   mass = 1;
   elasticity = 1;
   friction = 0.6;
   pickupRadius = 2;
	pickUpName = "a Rapidlauncher";

   computeCRC = true;
   emap = true;
};
datablock ShapeBaseImageData(rapidlauncherimage)
{
   className = WeaponImage;
   shapeFile = "weapon_mortar.dts";
   item = rapidlauncher;
   usesenergy = true;//forgot the ;
   offset = "0 0 0"; //woot, i spent hours trying to figure out what was wrong
   emap = true;

   projectile = rapidShot;
   projectileType = GrenadeProjectile;

         stateName[0] = "Activate";
   stateTransitionOnTimeout[0] = "ActivateReady";
   stateTimeoutValue[0] = 0.5;
   stateSequence[0] = "Activate";
   stateSound[0] = MortarSwitchSound;

   stateName[1] = "ActivateReady";
   stateTransitionOnLoaded[1] = "Ready";

   stateName[2] = "Ready";
   stateTransitionOnTriggerDown[2] = "Fire";
   //stateSound[2] = MortarIdleSound;

   stateName[3] = "Fire";
   stateSequence[3] = "Recoil";
   stateTransitionOnTimeout[3] = "Reload";
   stateTimeoutValue[3] = 0.1;
   stateFire[3] = true;
   stateRecoil[3] = LightRecoil;
   stateAllowImageChange[3] = false;
   stateScript[3] = "onFire";
   stateSound[3] = MortarFireSound;

   stateName[4] = "Reload";// like dude this is an energy weapon ;)
   stateTransitionOnNoAmmo[4] = "ready";
   stateTransitionOnTimeout[4] = "Ready";
   stateTimeoutValue[4] = 0.1;
   stateAllowImageChange[4] = false;
   stateSequence[4] = "Reload";
   stateSound[4] = MortarReloadSound;


};
////////////////////////////////////////
//////////////////////////////////////
////////////////////////////////////
//neato blue sparks!!!!!!!////////
/////////////////////////////////
